(* completion.sig *)

(* Copyright (C) 2006 Alley Stoughton

   This file is part of crypto, a cryptogram encoder/decoder.  See the
   file COPYING.txt for copying and usage restrictions *)

(* command completion *)

signature COMPLETION =
sig

datatype result =
           None
         | Unique of string
         | Ambiguous

(* complete xs returns a function that, when called with a string s,
   returns:

     None, if s is a prefix of no elements of xs;

     Unique s', if s' is the unique element of xs that s is a prefix
     of;

     Ambiguous, if s is a prefix of more than one element of xs *)

val complete : StringSet.set -> string -> result

end;
